package interpreter;

import static org.junit.Assert.*;
import java.util.List;
import org.junit.Test;

public class Milestone2Test {

	@Test
    public void testProgram1() {
        StringBuilder code = new StringBuilder();
        code.append("function a {");
        code.append("  var x;");
        code.append("  x = 55;");
        code.append("  b();");
        code.append("}");
        code.append("function b {");
        code.append("  print(x);");
        code.append("}");
        code.append("var x;");
        code.append("x = 1;");
        code.append("a();");

        TinyPLParser.ProgramContext tree = Util.parseCode(code.toString());
        Milestone2 interpreter = new Milestone2(tree);
        List<String> output = interpreter.run();
        assertEquals(1, output.size());
        assertEquals("1", output.get(0));
    }

    @Test
    public void testProgram2() {
        StringBuilder code = new StringBuilder();

        code.append("function a {");
        code.append("  var x;");
        code.append("  x = 3;");
        code.append("  print(x);");
        code.append("}");
        code.append("var x;");
        code.append("x = 2;");
        code.append("a();");

        TinyPLParser.ProgramContext tree = Util.parseCode(code.toString());
        Milestone2 interpreter = new Milestone2(tree);
        List<String> output = interpreter.run();
        assertEquals(1, output.size());
        assertEquals("3", output.get(0));
    }

}
